=== docs/examples/requirements.txt ===
numpy==1.15.0
matplotlib==2.2.2
Keras==2.2.4
Pillow==8.3.2
scikit_learn==0.21.3
