## sptag 0.0~git20210816.e724b01+ds

=== debian/changelog ===
sptag (0.0~git20210816.e724b01+ds-3) unstable; urgency=medium

  * Override ctest timeout from default 25m to 12h

 -- Paul Wise <pabs@debian.org>  Sat, 21 Aug 2021 18:35:13 +0800

sptag (0.0~git20210816.e724b01+ds-2) unstable; urgency=medium

  * Switch to running tests from cmake/ctest
  * Make the test output verbose since they are long tests

 -- Paul Wise <pabs@debian.org>  Sat, 21 Aug 2021 15:04:45 +0800

sptag (0.0~git20210816.e724b01+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Add missing build dependencies
  * Add patches to fix adding compiler flags
  * Enable running the build tests
  * Declare compliance with Debian Policy version 4.6.0

 -- Paul Wise <pabs@debian.org>  Sat, 21 Aug 2021 13:53:04 +0800

sptag (0.0~git20210514.20d55e1+ds-1) unstable; urgency=medium

  * Initial release (Closes: #987809)

 -- Paul Wise <pabs@debian.org>  Fri, 30 Apr 2021 11:09:09 +0800
