=== debian/control ===
Source: sptag
Section: math
Priority: optional
Maintainer: Paul Wise <pabs@debian.org>
Build-Depends:
 cmake (>= 3.12.0~),
 debhelper-compat (= 13),
 dh-sequence-python3,
 libboost-dev (>= 1.67~),
# remove system after 1.74, see 0001-Remove-unused-Boost-component-dependencies.patch
 libboost-system-dev (>= 1.67~),
 libboost-test-dev (>= 1.67~) <!nocheck>,
 python3-dev,
 swig (>= 3.0~),
Standards-Version: 4.6.0
Homepage: https://github.com/microsoft/SPTAG
Rules-Requires-Root: no

Package: python3-sptag
Section: python
# https://github.com/microsoft/SPTAG/issues/134
# https://github.com/microsoft/SPTAG/pull/136
Architecture: amd64 i386
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
XB-Python-Version:
 ${python3:Versions}
Description: Python distributed approximate nearest neighborhood search (ANN)
 A distributed approximate nearest neighborhood search (ANN) library
 which provides a high quality vector index build, search and
 distributed online serving toolkits for large scale vector search
 scenario.
 .
 This package contains the Python bindings.

Package: sptag
# https://github.com/microsoft/SPTAG/issues/134
# https://github.com/microsoft/SPTAG/pull/136
Architecture: amd64 i386
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: distributed approximate nearest neighborhood search (ANN)
 A distributed approximate nearest neighborhood search (ANN) library
 which provides a high quality vector index build, search and
 distributed online serving toolkits for large scale vector search
 scenario.
 .
 This package contains the client, server, aggregator and index
 builder and searcher.
