=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

# ctest normally suppresses test output
# https://cmake.org/cmake/help/latest/manual/ctest.1.html#options
# but that could result in buildd timeout
# the tests take a long time, try 12h
override_dh_auto_test:
	dh_auto_test -- ARGS+="--verbose --timeout 43200"
