## sptag 0.0~git20211105.0bf0ef5+ds

=== debian/changelog ===
sptag (0.0~git20211105.0bf0ef5+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
    - Add patch to fix FTBFS due to missing #include <mutex>
    - Add new Boost filesystem test dependency
  * Delegate test verbosity to debhelper when it is new enough
  * Reduce ctest timeout to 2h, current test runs are under 1h
  * Drop XB-Python-Version as it is not used by dh-python
  * Inform autodep8-python3 that the import name is SPTAG

 -- Paul Wise <pabs@debian.org>  Sat, 06 Nov 2021 10:16:23 +0800
