=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
  debhelper-compat (= 13),
  dh-sequence-python3,
  libboost-dev (>= 1.67~),
+ libboost-filesystem-dev (>= 1.67~) <!nocheck>,
 # remove system after 1.74, see 0001-Remove-unused-Boost-component-dependencies.patch
  libboost-system-dev (>= 1.67~),
  libboost-test-dev (>= 1.67~) <!nocheck>,
@@ -27,8 +28,6 @@
  ${shlibs:Depends},
 Provides:
  ${python3:Provides},
-XB-Python-Version:
- ${python3:Versions}
 Description: Python distributed approximate nearest neighborhood search (ANN)
  A distributed approximate nearest neighborhood search (ANN) library
  which provides a high quality vector index build, search and
