## sptag 0.0~git20211209.a84a9e4%2Bds

=== debian/changelog ===
sptag (0.0~git20211209.a84a9e4+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Paul Wise <pabs@debian.org>  Mon, 20 Dec 2021 12:24:06 +0800

sptag (0.0~git20211209.a84a9e4+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  - Drop support for i386 as upstream doesn't support it 
  * Increase ctest timeout to 3h due to timeout on repro builds server

 -- Paul Wise <pabs@debian.org>  Fri, 10 Dec 2021 14:46:49 +0800
