## sptag 0.0~git20211209.a84a9e4+ds

=== debian/changelog ===
sptag (0.0~git20211209.a84a9e4+ds-1~bpo10+1) buster-backports-sloppy; urgency=medium

  * Rebuild for buster-backports-sloppy.

 -- Paul Wise <pabs@debian.org>  Mon, 20 Dec 2021 13:07:42 +0800
