=== debian/control ===
--- 
+++ 
@@ -21,7 +21,8 @@
 Section: python
 # https://github.com/microsoft/SPTAG/issues/134
 # https://github.com/microsoft/SPTAG/pull/136
-Architecture: amd64 i386
+# https://github.com/microsoft/SPTAG/issues/246
+Architecture: amd64
 Depends:
  ${misc:Depends},
  ${python3:Depends},
@@ -39,7 +40,8 @@
 Package: sptag
 # https://github.com/microsoft/SPTAG/issues/134
 # https://github.com/microsoft/SPTAG/pull/136
-Architecture: amd64 i386
+# https://github.com/microsoft/SPTAG/issues/246
+Architecture: amd64
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
