=== debian/rules ===
--- 
+++ 
@@ -2,8 +2,9 @@
 #export DH_VERBOSE = 1
 
 # tests usually take just under an hour
-# use 2h instead of the default 25m
-TEST_ARGS = --timeout 7200
+# repro build servers can take longer
+# use 3h instead of the default 25m
+TEST_ARGS = --timeout 10800
 
 # ctest normally suppresses test output
 # https://cmake.org/cmake/help/latest/manual/ctest.1.html#options
@@ -18,10 +19,10 @@
 endif
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+#export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
 
 %:
 	dh $@
 
 override_dh_auto_test:
-	dh_auto_test -- ARGS+="$(TEST_ARGS)"
+	dh_auto_test -- ARGS+="$(TEST_ARGS)"
