## sptag 0.0~git20220113.216a17a+ds

=== debian/changelog ===
sptag (0.0~git20220113.216a17a+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Reduce Boost version requirement in line with upstream

 -- Paul Wise <pabs@debian.org>  Tue, 25 Jan 2022 14:39:38 +0800
