=== debian/control ===
--- 
+++ 
@@ -6,11 +6,11 @@
  cmake (>= 3.12.0~),
  debhelper-compat (= 13),
  dh-sequence-python3,
- libboost-dev (>= 1.67~),
- libboost-filesystem-dev (>= 1.67~) <!nocheck>,
+ libboost-dev (>= 1.66~),
+ libboost-filesystem-dev (>= 1.66~) <!nocheck>,
 # remove system after 1.74, see 0001-Remove-unused-Boost-component-dependencies.patch
- libboost-system-dev (>= 1.67~),
- libboost-test-dev (>= 1.67~) <!nocheck>,
+ libboost-system-dev (>= 1.66~),
+ libboost-test-dev (>= 1.66~) <!nocheck>,
  python3-dev,
  swig (>= 3.0~),
 Standards-Version: 4.6.0
