## sptag 0.0~git20220211.c640c3c+ds

=== debian/changelog ===
sptag (0.0~git20220211.c640c3c+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Bump copyright year for a new file
  * Enable autodep8 tests

 -- Paul Wise <pabs@debian.org>  Wed, 16 Feb 2022 16:22:56 +0800
