=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
 Standards-Version: 4.6.0
 Homepage: https://github.com/microsoft/SPTAG
 Rules-Requires-Root: no
+Testsuite: autopkgtest-pkg-python
 
 Package: python3-sptag
 Section: python
