=== debian/rules ===
--- 
+++ 
@@ -25,4 +25,4 @@
 	dh $@
 
 override_dh_auto_test:
-	dh_auto_test -- ARGS+="$(TEST_ARGS)" 
+	dh_auto_test -- ARGS+="$(TEST_ARGS)"
