## sptag 0.0~git20220617.6f44a02+ds

=== debian/changelog ===
sptag (0.0~git20220617.6f44a02+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
    - Delete ThirdParty directory that includes zstd
    - Add patch to use system zstd
  * Add new build-dep on zstd
  * Declare compliance with Debian Policy version 4.6.1

 -- Paul Wise <pabs@debian.org>  Tue, 21 Jun 2022 15:13:57 +0800

sptag (0.0~git20220411.2a81715+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Add patch updating CMake files from C++ 14 to 17,
    upstream updated MSVC but forgot the CMake files.
  * Use cmake build system, ignoring the setup.py file
  * Bump copyright year for debian/ directory

 -- Paul Wise <pabs@debian.org>  Sat, 23 Apr 2022 16:37:32 +0800
