## sptag 0.0~git20220729.a192a17+ds

=== debian/changelog ===
sptag (0.0~git20220729.a192a17+ds-2) unstable; urgency=medium

  * Add patch to fix build failure on tmpfs due to O_DIRECT

 -- Paul Wise <pabs@debian.org>  Mon, 01 Aug 2022 10:38:33 +0800

sptag (0.0~git20220729.a192a17+ds-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add patch to print file open error info, should help debug failure

 -- Paul Wise <pabs@debian.org>  Sun, 31 Jul 2022 15:24:38 +0800

sptag (0.0~git20220718.5ab4ced+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Add unmerged upstream patch fixing reconstruct tests (Closes: #1013563)
  * Add patch to switch from AVX512 by default to GCC FMV, fixes test failure

 -- Paul Wise <pabs@debian.org>  Mon, 18 Jul 2022 14:02:12 +0800
