=== debian/control ===
--- 
+++ 
@@ -11,9 +11,10 @@
 # remove system after 1.74, see 0001-Remove-unused-Boost-component-dependencies.patch
  libboost-system-dev (>= 1.66~),
  libboost-test-dev (>= 1.66~) <!nocheck>,
+ libzstd-dev,
  python3-dev,
  swig (>= 3.0~),
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/microsoft/SPTAG
 Rules-Requires-Root: no
 Testsuite: autopkgtest-pkg-python
