=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 #export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
 
 %:
-	dh $@
+	dh $@ --buildsystem=cmake
 
 override_dh_auto_test:
 	dh_auto_test -- ARGS+="$(TEST_ARGS)"
