## sptag 0.0~git20221103.3d76e5e+ds

=== debian/changelog ===
sptag (0.0~git20221103.3d76e5e+ds-1build1) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 25 Dec 2022 20:43:07 +0000

sptag (0.0~git20221103.3d76e5e+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches

 -- Paul Wise <pabs@debian.org>  Sun, 13 Nov 2022 13:53:58 +0800
