## sptag 0.0~git20230106.de5b7f8+ds

=== debian/changelog ===
sptag (0.0~git20230106.de5b7f8+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Add patch fixing various spelling and grammar errors
  * Declare compliance with Debian Policy version 4.6.1, no changes needed

 -- Paul Wise <pabs@debian.org>  Sun, 05 Feb 2023 12:04:44 +0800
