## sptag 0.0~git20230301.0207479+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -78,7 +78,7 @@
     message (FATAL_ERROR "Could no find openmp!")
 endif()
 
-find_package(Boost 1.67 COMPONENTS system thread serialization wserialization regex filesystem)
+find_package(Boost 1.66 COMPONENTS system thread serialization wserialization regex filesystem)
 if (Boost_FOUND)
     include_directories (${Boost_INCLUDE_DIR})
     link_directories (${Boost_LIBRARY_DIR})
@@ -92,6 +92,9 @@
 
 option(GPU "GPU" ON)
 option(LIBRARYONLY "LIBRARYONLY" OFF)
+
+add_subdirectory (ThirdParty/zstd/build/cmake)
+
 add_subdirectory (AnnService)
 add_subdirectory (Test)
 add_subdirectory (GPUSupport)
