=== Wrappers/CMakeLists.txt ===
--- 
+++ 
@@ -1,34 +1,34 @@
 # Copyright (c) Microsoft Corporation. All rights reserved.
 # Licensed under the MIT License.
 
-find_package(Python2 COMPONENTS Development)
+
+find_package(Python3 COMPONENTS Development)
 
 find_package(CUDA)
 
-if (NOT GPU)
+if ((NOT GPU) OR (NOT Python3_FOUND))
     set (CUDA_FOUND false)
 endif()
 
 if (CUDA_FOUND)
     message (STATUS "Found cuda.")
-    set (Python2_FOUND false)
 else()
     message (STATUS "Could not find cuda.")
 endif()
 
-if (Python2_FOUND)
-    include_directories (${Python2_INCLUDE_DIRS})
-    link_directories (${Python2_LIBRARY_DIRS})
-    set (Python_INCLUDE_DIRS ${Python2_INCLUDE_DIRS})
-    set (Python_LIBRARIES ${Python2_LIBRARIES})
+if (Python3_FOUND)
+    include_directories (${Python3_INCLUDE_DIRS})
+    link_directories (${Python3_LIBRARY_DIRS})
+    set (Python_INCLUDE_DIRS ${Python3_INCLUDE_DIRS})
+    set (Python_LIBRARIES ${Python3_LIBRARIES})
     set (Python_FOUND true)
 else()
-    find_package(Python3 COMPONENTS Development)
-    if (Python3_FOUND)
-        include_directories (${Python3_INCLUDE_DIRS})
-        link_directories (${Python3_LIBRARY_DIRS})
-        set (Python_INCLUDE_DIRS ${Python3_INCLUDE_DIRS})
-        set (Python_LIBRARIES ${Python3_LIBRARIES})
+    find_package(Python2 COMPONENTS Development)
+    if (Python2_FOUND)
+        include_directories (${Python2_INCLUDE_DIRS})
+        link_directories (${Python2_LIBRARY_DIRS})
+        set (Python_INCLUDE_DIRS ${Python2_INCLUDE_DIRS})
+        set (Python_LIBRARIES ${Python2_LIBRARIES})
         set (Python_FOUND true)
     endif()
 endif()
