=== docs/examples/requirements.txt ===
numpy==1.21.0
matplotlib==2.2.2
Keras==2.2.4
Pillow==9.0.1
scikit_learn==0.21.3
