=== debian/changelog ===
sptag (0.0~git20230301.0207479+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Declare compliance with Debian Policy version 4.6.2, no changes needed

 -- Paul Wise <pabs@debian.org>  Wed, 01 Mar 2023 16:36:13 +0800
