=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  libzstd-dev,
  python3-dev,
  swig (>= 3.0~),
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/microsoft/SPTAG
 Rules-Requires-Root: no
 Testsuite: autopkgtest-pkg-python
